import java.net.*;
import java.io.*;
import java.util.*;

public class AquaServer {
	static Vector clientList= new Vector();
	static PrintWriter screenOut = new PrintWriter(System.out, true);

	public static void main(String[] args) throws IOException {
		ServerSocket serverSocket = null;
		boolean listening = true;
		Thread tempThread;
		AquaClientThread tempClient;
		int currentNode;
		screenOut.println("\nA|Q|U|A Server v0.01");
		screenOut.println(" Copyright 2000 by Branden J. Hall of Fig Leaf Software");
		screenOut.println(" http://www.figleaf.com | bhall@figleaf.com");
		screenOut.println("  Authors notes:");
		screenOut.println("   This server was thrown together in less than a day and");	
		screenOut.println("   I haven't touched Java in about 4 years, so you do the math...");
		screenOut.println("   This sucker probably has some bugs! If you run across something");
		screenOut.println("   wrong, please email me at the address above with details.");
		screenOut.println("   Thanks to Dave Watts, Kurt Hakenson, Patti Lee, and the");
		screenOut.println("   rest of the Notorius F.I.G.");
		screenOut.println("------------------------------------------------------\n");
		if  (args.length >= 1){
			Integer tempPort = new Integer(args[0]);
			try{
				serverSocket = new ServerSocket(tempPort.intValue());
			}catch(IOException e){
				System.err.println("Could not listen on port: "+args[0]);
				System.exit(-1);
			}
				screenOut.println("Server started and listening on port "+args[0]);
			while (listening){
				tempClient = new AquaClientThread(serverSocket.accept());
				clientList.add(tempClient);
				tempThread = new Thread(tempClient);
				tempThread.start();
			}
			serverSocket.close();
		}else{
			screenOut.println("Error: incorrect number of arguments");
			screenOut.println("usage: java AquaServer <port>");
			screenOut.println("Where <port> is an unused port greater than 1024 that the");
			screenOut.println("server will listen on.");
			System.exit(-1);
		}
	}
	
	static void sendToAllClients(String message){
		int i;
		AquaClientThread foo;
		AquaClientThread fooip;
		AquaClientThread tempClient;
		for (i=0;i<clientList.size();++i){
			foo = (AquaClientThread)clientList.get(i);
			foo.send(message);
		} 	
	}
	
	static void deleteClient(AquaClientThread deadClient){
		int num;
		screenOut.println("Client disconnect: "+deadClient.clientIP);
		num=clientList.indexOf(deadClient);
		clientList.remove(num);
	}
}

class AquaClientThread extends Thread {
	PrintWriter screenOut = new PrintWriter(System.out, true);
	private Socket socket = null;
	public String clientIP;
	public PrintWriter out;
	public BufferedReader in;

	public AquaClientThread(Socket socket){
		super("AquaClientThread");
		this.socket = socket;
	}
	
	public void run(){
		clientIP = socket.getInetAddress().getHostAddress();
		screenOut.println("Client connect: "+clientIP);
		try{
			out = new PrintWriter(socket.getOutputStream(), true);
			in = new BufferedReader (new InputStreamReader(socket.getInputStream()));
			String inputLine;
			char buf[] = new char[1];
			while (in.read(buf, 0 ,1)!=-1){
				inputLine = "";
				while(buf[0]!='\u0000'){
					inputLine = inputLine + buf[0];
					in.read(buf, 0 ,1);
				}
				inputLine = inputLine + '\u0000';
				AquaServer.sendToAllClients(inputLine);
			}
			AquaServer.deleteClient(this);
			in.close();
			out.close();
			socket.close();
		}catch(IOException e){
			e.printStackTrace();
		}
	}
	
	public void send(String message){
		out.println(message);
	}
}
